librevenge::RVNGStringStream Class Reference documentation

librevenge::RVNGStringStream Class Reference

`#include <RVNGStreamImplementation.h>`

Inheritance diagram for librevenge::RVNGStringStream:

## Public Member Functions
| RVNGStringStream (const unsigned char *data, const unsigned int dataSize)
| ~RVNGStringStream ()
const unsigned char * | read (unsigned long numBytes, unsigned long &numBytesRead)
| Tries to read a given number of bytes starting from the current position inside the input stream.
long | tell ()
| Returns the actual position inside the input stream.
int | seek (long offset, RVNG_SEEK_TYPE seekType)
| Moves to the next location inside the input stream.
bool | isEnd ()
| Determines whether the current position is at the end of the stream.
bool | isStructured ()
| Analyses the content of the input stream to see whether it is an OLE2 storage.
unsigned | subStreamCount ()
const char * | subStreamName (unsigned)
bool | existsSubStream (const char *name)
RVNGInputStream * | getSubStreamByName (const char *name)
| Extracts a `named` stream from an OLE2 storage.
RVNGInputStream * | getSubStreamById (unsigned)
Public Member Functions inherited from librevenge::RVNGInputStream
| RVNGInputStream ()
virtual | ~RVNGInputStream ()

## Private Member Functions
| RVNGStringStream (const RVNGStringStream &)
RVNGStringStream & | operator= (const RVNGStringStream &)

## Private Attributes
RVNGStringStreamPrivate * | d

## Constructor & Destructor Documentation

## ◆ RVNGStringStream() [1/2]

librevenge::RVNGStringStream::RVNGStringStream | ( | const unsigned char * | data,
|  | const unsigned int | dataSize )

Referenced by getSubStreamByName(), operator=(), and RVNGStringStream().

## ◆ ~RVNGStringStream()

librevenge::RVNGStringStream::~RVNGStringStream | ( |  | ) |

## ◆ RVNGStringStream() [2/2]

librevenge::RVNGStringStream::RVNGStringStream | ( | const RVNGStringStream & |  | ) |
| private

## Member Function Documentation

## ◆ existsSubStream()

bool librevenge::RVNGStringStream::existsSubStream | ( | const char * | name | ) |
| virtual

Implements librevenge::RVNGInputStream.

## ◆ getSubStreamById()

RVNGInputStream * librevenge::RVNGStringStream::getSubStreamById | ( | unsigned | id | ) |
| virtual

Implements librevenge::RVNGInputStream.

## ◆ getSubStreamByName()

RVNGInputStream * librevenge::RVNGStringStream::getSubStreamByName | ( | const char * | name | ) |
| virtual

Extracts a `named` stream from an OLE2 storage.

Returns
  Should be a pointer to RVNGInputStream constructed from the `named` stream if it exists.
  Should be 0, if the `named` stream does not exist inside the OLE2 storage or if the input stream is not an OLE2 storage.

Implements librevenge::RVNGInputStream.

Referenced by getSubStreamById().

## ◆ isEnd()

bool librevenge::RVNGStringStream::isEnd | ( |  | ) |
| virtual

Determines whether the current position is at the end of the stream.

Returns
  A boolean value that should be true if the next location to be read in the input stream is beyond its end. In all other cases, it should be false.

Implements librevenge::RVNGInputStream.

## ◆ isStructured()

bool librevenge::RVNGStringStream::isStructured | ( |  | ) |
| virtual

Analyses the content of the input stream to see whether it is an OLE2 storage.

Returns
  A boolean value that should be true if the input stream is an OLE2 storage and false if it is not the case

Implements librevenge::RVNGInputStream.

Referenced by existsSubStream(), getSubStreamByName(), subStreamCount(), and subStreamName().

## ◆ operator=()

RVNGStringStream & librevenge::RVNGStringStream::operator= | ( | const RVNGStringStream & |  | ) |
| private

## ◆ read()

const unsigned char * librevenge::RVNGStringStream::read | ( | unsigned long | numBytes,
|  | unsigned long & | numBytesRead )
| virtual

Tries to read a given number of bytes starting from the current position inside the input stream.

Parameters

  numBytes | Number of bytes desired to be read.
  numBytesRead | Number of bytes that were possible to be read.

Returns
  Should be a pointer to an array of numBytesRead bytes (unsigned char[numBytesRead]).
  Optionally it could be 0 if the desired number of bytes could not be read.

Implements librevenge::RVNGInputStream.

## ◆ seek()

int librevenge::RVNGStringStream::seek | ( | long | offset,
|  | RVNG_SEEK_TYPE | seekType )
| virtual

Moves to the next location inside the input stream.

Parameters

  offset | The offset of the location inside the input stream to move to. It is relative either to the current position or to the beginning of the input stream depending on the value of the `seekType` parameter.
  seekType | Determines whether the `offset` is relative to the beginning of the input stream (`RVNG_SEEK_SET`) or to the current position (`RVNG_SEEK_CUR`).

Returns
  An integer value that should be 0 (zero) if the seek was successful and any other value if it failed (i.e. the requested `offset` is beyond the end of the input stream or before its beginning).

Implements librevenge::RVNGInputStream.

Referenced by getSubStreamByName(), and isStructured().

## ◆ subStreamCount()

unsigned librevenge::RVNGStringStream::subStreamCount | ( |  | ) |
| virtual

Implements librevenge::RVNGInputStream.

## ◆ subStreamName()

const char * librevenge::RVNGStringStream::subStreamName | ( | unsigned | id | ) |
| virtual

Implements librevenge::RVNGInputStream.

Referenced by getSubStreamById().

## ◆ tell()

long librevenge::RVNGStringStream::tell | ( |  | ) |
| virtual

Returns the actual position inside the input stream.

Returns
  A long integer value that should correspond to the position of the next location to be read in the input stream.

Implements librevenge::RVNGInputStream.

## Member Data Documentation

## ◆ d

RVNGStringStreamPrivate* librevenge::RVNGStringStream::d
| private

Referenced by existsSubStream(), getSubStreamByName(), isEnd(), isStructured(), read(), RVNGStringStream(), seek(), subStreamCount(), subStreamName(), tell(), and ~RVNGStringStream().

The documentation for this class was generated from the following files:

- RVNGStreamImplementation.h
- RVNGStreamImplementation.cpp